﻿-- DEFAULT_CHAT_FRAME:AddMessage("Piercing Shot crit kill");

local FLASK_SOUNDS = {
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0036.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0037.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0043.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0068.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0069.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0070.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0072.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0074.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0088.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0089.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0090.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0092.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0093.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0098.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0099.mp3",
 "Interface\\AddOns\\EpicHunterTristana\\Base\\File0100.mp3",
}
local ACHIV_SOUNDS = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0016.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0160.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0188.mp3",
}

local SOUNDS_BARRAGE = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0079.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0080.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0081.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0082.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0083.mp3",

}


local MISSING_SHOTS = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0047.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0094.mp3",
}

local LOOKOUT_SOUND = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0190.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0191.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0192.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0193.mp3",
}



local BLACKARROW_SOUND = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0127.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0129.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0178.mp3",
}



local CHEETAH_SOUND = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0110.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0111.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0120.mp3",

}


local DEAD_SOUND = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0056.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0057.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0058.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0059.mp3",
}


local PIERCING_CRIT = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0013.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0021.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0025.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0026.mp3",
}


local PIERCING_HIT = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0006.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0027.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0028.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0125.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0126.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0173.mp3",
}

local HEARTH_SOUND = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0105.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0106.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0107.mp3",
}

local NARROW_FALL = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0146.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0147.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0150.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0153.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0156.mp3",
}

local DISENGAGE_SOUND = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0060.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0061.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0062.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0063.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0064.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0065.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0066.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0067.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0113.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0114.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0115.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0116.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0117.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0118.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0133.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0134.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0135.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0136.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0137.mp3",
}

local BURSTING_SHOT = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0017.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0139.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0140.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0141.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0181.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0183.mp3",

}
local REMOVE_CC = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0148.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0161.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0180.mp3",
}
local RESSURECT_SOUND = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0108.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0109.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0097.mp3",
}

local BARELY_SURVIVE = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0149.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0152.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0154.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0155.mp3",
}

local AIMED_START = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0004.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0008.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0009.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0010.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0012.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0015.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0018.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0177.mp3",

"Interface\\AddOns\\EpicHunterTristana\\Base\\File0179.mp3",
}


--"Interface\\AddOns\\EpicHunterTristana\\Base\\File0001.mp3", -- "i'm going in!"
local TRUESHOT_SOUND = {
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0002.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0007.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0112.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0123.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0124.mp3",
"Interface\\Addons\\EpicHunterTristana\\Base\\File0132.mp3",
"Interface\\AddOns\\EpicHunterTristana\\Base\\File0158.mp3",
}

SoundChannel = "Ambience" -- other channels: master, SFX, Music

-- COMMENT Detect kills with Barrage and play sound file if more than 2 kills
local Barrage_Kill_Count = 0;

local frame = CreateFrame("FRAME");
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
frame:SetScript("OnEvent", function(self, event, ...)
	local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		if (type == "SPELL_DAMAGE") then
			local SourceName = select(5, ...)
			local spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(12, ...)
			if (spellId == 120361 and overkill > 0  and SourceName == UnitName("player")) then
				Barrage_Kill_Count = Barrage_Kill_Count + 1
					if (Barrage_Kill_Count == 3) then
					PlaySoundFile(SOUNDS_BARRAGE[random(#SOUNDS_BARRAGE)], SoundChannel); 
					end
			end
		end
	end
end);

-- COMMENT Detect autoshots to reset kill count on Barrage

local frame2 = CreateFrame("FRAME");
frame2:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
frame2:SetScript("OnEvent", function(self, event, ...)
	local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		if (type == "RANGE_DAMAGE") then
			local SourceName = select(5, ...)
			if (SourceName == UnitName("player")) then
				Barrage_Kill_Count = 0
				Missed_Shot_Sound_Played = 0
				Bursting_Shot_Sound_Played = 0
				Barely_Survived_Sound_Played = 0
				ressurected = 0
				achiv_sound_played = 0
			end
		end
	end
end);

-- COMMENT Plays a sound file when Piercing Shot kills something, different sound files for crit and hit kills

Piercing_Shot_Sound_Played = 0

local frame3 = CreateFrame("FRAME");
frame3:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
frame3:SetScript("OnEvent", function(self, event, ...)

	local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
	
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		if (type == "SPELL_DAMAGE") then
			local SourceName = select(5, ...)
			local spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(12, ...)
			if (spellId == 198670 and overkill > 0 and SourceName == UnitName("player")) then
				if (critical) then
					if (Piercing_Shot_Sound_Played == 0) then
					PlaySoundFile(PIERCING_CRIT[random(#PIERCING_CRIT)], SoundChannel);


					Piercing_Shot_Sound_Played = 1
					end
				else
					if (Piercing_Shot_Sound_Played == 0) then
					PlaySoundFile(PIERCING_HIT[random(#PIERCING_HIT)], SoundChannel);


					Piercing_Shot_Sound_Played = 1
					end
				end
			end
		end
	end
end);

-- COMMENT Detect Piercing Shot cast to reset sound played on Piercing Shot kills, and plays a sound file when casting Hawkeye or Flare

local frame4 = CreateFrame("FRAME");
frame4:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
frame4:SetScript("OnEvent", function(self, event, unit, SpellName)
	if (unit == "player") then 
		if(SpellName == GetSpellInfo(198670)) then 
		Piercing_Shot_Sound_Played = 0
		end
		if(SpellName == GetSpellInfo(6197) or SpellName == GetSpellInfo(1543)) then -- Hawkeye or Flare
		PlaySoundFile(LOOKOUT_SOUND[random(#LOOKOUT_SOUND)], SoundChannel);


		end
		if(SpellName == GetSpellInfo(59752) or SpellName == GetSpellInfo(195710) or SpellName == GetSpellInfo(20589)) then -- Every man for himself / PVP medallion / Escape Artist
		PlaySoundFile(REMOVE_CC[random(#REMOVE_CC)], SoundChannel);


		end
		if(SpellName == GetSpellInfo(203233)) then -- aspect-of-the-cheetah
			if (random(4) > 2) then PlaySoundFile(CHEETAH_SOUND[random(#CHEETAH_SOUND)], SoundChannel) end
		end
	end
end);

-- COMMENT Plays a sound when you narrowly survive a nasty fall

Barely_Survived_Sound_Played = 0

local frame6 = CreateFrame("FRAME");
frame6:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
frame6:SetScript("OnEvent", function(self, event, ...)
	local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...

	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		if (type == "ENVIRONMENTAL_DAMAGE") then
			local name = select(9, ...)
			local type = select(12, ...)
			local amount = select(13, ...)
			if (name == UnitName("player") and type == "Falling") then
				local max_health = UnitHealthMax("player");
				local health = UnitHealth("player");
				
				if ((health / max_health) < 0.2 and (health - amount) > 0) then
					if (Barely_Survived_Sound_Played == 0) then
					PlaySoundFile(NARROW_FALL[random(#NARROW_FALL)], SoundChannel);


					Barely_Survived_Sound_Played = 1
					end
				end
			end
		end
	end
end);

-- COMMENT Plays sound when casting Disengage

local frame7 = CreateFrame("FRAME");
frame7:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
frame7:SetScript("OnEvent", function(self, event, unit, SpellName, unk, unk2, SpellID)
	if (SpellID == 781 and unit == "player") then 
	PlaySoundFile(DISENGAGE_SOUND[random(#DISENGAGE_SOUND)], SoundChannel);
	end
	if (SpellID == 58984 or SpellID == 5215 or SpellID == 1784 or SpellID == 1856 or SpellID == 90328 or SpellID == 22450 or SpellID == 66) then 
		-- Shadowmeld, Prowl, Stealth, Vanish, spirit beast stealth, pet stealth, invisibility
		if(UnitReaction("player", unit) < 4) then
		DEFAULT_CHAT_FRAME:AddMessage("Stealth detected");
		PlaySoundFile("Interface\\AddOns\\EpicHunterTristana\\Base\\File0020.mp3", SoundChannel);
		end
	end
end);

-- COMMENT Plays sound when shots miss

Missed_Shot_Sound_Played = 0

local frame8 = CreateFrame("FRAME");
frame8:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
frame8:SetScript("OnEvent", function(self, event, ...)

	local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
	
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		if (type == "SPELL_MISSED" or type == "RANGE_MISSED") then
			local SourceName = select(5, ...)
			if (SourceName == UnitName("player")) then
				if (Piercing_Shot_Sound_Played == 0) then
				PlaySoundFile(MISSING_SHOTS[random(#MISSING_SHOTS)], SoundChannel);


				Piercing_Shot_Sound_Played = 1
				end
			end
		end
	end
end);

-- COMMENT Plays sound when Bursting Shot disorients something, when you activate Trueshot, Blackarrow (rarely), eat a Flask, drop with a parachute (sometimes)

Bursting_Shot_Sound_Played = 0

local frame9 = CreateFrame("FRAME");
frame9:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
frame9:SetScript("OnEvent", function(self, event, ...)
	local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...

	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		if (type == "SPELL_AURA_APPLIED" or type == "SPELL_AURA_REFRESH") then
		local name = select(5, ...)
		local aura_ID = select(12, ...)
			if (name == UnitName("player")) then
				if (aura_ID == 224729) then 
					if (Bursting_Shot_Sound_Played == 0) then
					PlaySoundFile(BURSTING_SHOT[random(#BURSTING_SHOT)], SoundChannel);
					Bursting_Shot_Sound_Played = 1
					end
				end
				if (aura_ID == 193526) then 
				PlaySoundFile(TRUESHOT_SOUND[random(#TRUESHOT_SOUND)], SoundChannel);


				end
				if (aura_ID == 194599) then 
					if(random(10) > 9) then PlaySoundFile(BLACKARROW_SOUND[random(#BLACKARROW_SOUND)], SoundChannel); end
				end
				if (aura_ID == 176151 or aura_ID == 156073 or aura_ID == 156064 or aura_ID == 188033 or aura_ID == 188116) then
				PlaySoundFile(FLASK_SOUNDS[random(#FLASK_SOUNDS)], SoundChannel);
				end
			end
		end
		if (type == "SPELL_AURA_REMOVED") then
		local name = select(5, ...)
		local aura_ID = select(12, ...)
			if (name == UnitName("player") and aura_ID == 55002 or aura_ID == 55001) then -- Parachute
				if (random(4) > 2) then PlaySoundFile("Interface\\AddOns\\EpicHunterTristana\\Base\\File0145.mp3", SoundChannel) end
			end
		end
	end
end);


-- COMMENT Plays a sound file when you exit combat with little HP

local frame10 = CreateFrame("Frame")
frame10:RegisterEvent("PLAYER_REGEN_ENABLED")
frame10:SetScript("OnEvent", function(self, event, ...)
	local max_health = UnitHealthMax("player");
	local health = UnitHealth("player");
	if ((health / max_health) < 0.2 and health > 0) then
		if (Barely_Survived_Sound_Played == 0) then
		PlaySoundFile(BARELY_SURVIVE[random(#BARELY_SURVIVE)], SoundChannel);
		Barely_Survived_Sound_Played = 1
		end
	end
end)

-- COMMENT Plays a sound file when you cast Hearthstone, and when you start Aimed Shot

local frame11 = CreateFrame("Frame")
frame11:RegisterEvent("UNIT_SPELLCAST_START")
frame11:SetScript("OnEvent", function(self, event, ...)
	local unit = select(1,...)
	local SpellID = select(5, ...)
	if (unit == "player") then
		if (SpellID == 8690 or SpellID == 171253) then -- regular hearthstone and garrison
		PlaySoundFile(HEARTH_SOUND[random(#HEARTH_SOUND)], SoundChannel);
		end
		if (SpellID == 19434) then -- aimed shot
		local affectingCombat = UnitAffectingCombat("player");
			if (affectingCombat == false) then 
				if (random(4) > 2) then PlaySoundFile(AIMED_START[random(#AIMED_START)], SoundChannel); end
			end
		end
	end
end)

-- COMMENT Plays a sound file when you get ressurected by a player

ressurected = 0

local frame11 = CreateFrame("Frame")
frame11:RegisterEvent("PLAYER_ALIVE")
frame11:RegisterEvent("PLAYER_UNGHOST")
frame11:RegisterEvent("RESURRECT_REQUEST")
frame11:SetScript("OnEvent", function(self, event, ...)
	if (event == "RESURRECT_REQUEST") then ressurected = 1 end
	if (event == "PLAYER_ALIVE" or event == "PLAYER_UNGHOST") then 
		if (ressurected == 1) then
		PlaySoundFile(RESSURECT_SOUND[random(#RESSURECT_SOUND)], SoundChannel);
		ressurected = 0
		end
	end
end)

local frame12 = CreateFrame("Frame")
frame12:RegisterEvent("PLAYER_DEAD")
frame12:SetScript("OnEvent", function(self, event, ...)
	PlaySoundFile(DEAD_SOUND[random(#DEAD_SOUND)], SoundChannel);
end)

achiv_sound_played = 0

local frame13 = CreateFrame("Frame")
frame13:RegisterEvent("CHAT_MSG_ACHIEVEMENT")
frame13:SetScript("OnEvent", function(self, event, ...)
	local name = select(5, ...)
	if (name == UnitName("player")) then
		if(achiv_sound_played == 0) then
			if(random(4) > 3) then PlaySoundFile(ACHIV_SOUNDS[random(#ACHIV_SOUNDS)], SoundChannel); end
		achiv_sound_played = 1
		end
	end
end)